#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

mt19937 mrand(random_device{} ()); 

int rnd(int x) {
  return mrand() % x;
}

typedef long double ld;
typedef long long ll;

#ifdef DEBUG
#define eprintf(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define eprintf(...) ;
#endif

#define pb push_back
#define mp make_pair
#define sz(x) ((int) (x).size())
#define TASK "text"

const int inf = (int) 1.01e9;
const ld eps = 1e-9;
const ld pi = acos((ld) -1.0);

void precalc() {
}

struct R {
  int a, b;
  int id;

  R(int _a = 0, int _b = 1) : a(_a), b(_b), id(-1) {}

  R operator - (const R &r) const {
    return R(a * r.b - r.a * b, b * r.b);
  }

  inline bool operator < (const R &r) const {
    return (long long) a * r.b < (long long) b * r.a;
  }
};

const int maxn = (int) 2e3 + 10;
R a[maxn];

int n;

int read() {
  if (scanf("%d", &n) < 1) {
    return 0;
  }
  for (int i = 0; i < n; ++i) {
    int x, y;
    scanf("%d%d", &x, &y);
    a[i] = R(x, y);
    a[i].id = i;
  }
  return 1;
}

R mns[maxn][maxn][3];
R mxs[maxn][maxn][3];

void solve() {
  sort(a, a + n);

  for (int i = 0; i < n; ++i) {
    R mn1(inf, 1), mn2(inf, 1), mn3(inf, 1);
    for (int j = n - 1, rj = n - 1; j >= 0; --j) {
      if (i == j) {
        continue;
      }
      while (rj >= 0 && !(a[rj] < a[j])) {
        if (rj != i) {
          R cur(a[i].a + a[rj].a, a[i].b + a[rj].b);
          cur.id = rj;
          if (cur < mn3) {
            mn3 = cur;
            if (mn3 < mn2) {
              swap(mn3, mn2);
              if (mn2 < mn1) {
                swap(mn1, mn2);
              }
            }
          }
        }
        --rj;
      }
      {
        mns[i][j][0] = mn1, mns[i][j][1] = mn2, mns[i][j][2] = mn3;
      }
    }
  }

  for (int i = 0; i < n; ++i) {
    R mn1(0, 1), mn2(0, 1), mn3(0, 1);
    for (int j = 0, rj = 0; j < n; ++j) {
      if (i == j) {
        continue;
      }
      while (rj < n && !(a[j] < a[rj])) {
        if (rj != i) {
          R cur(a[i].a + a[rj].a, a[i].b + a[rj].b);
          cur.id = rj;
          if (mn3 < cur) {
            mn3 = cur;
            if (mn2 < mn3) {
              swap(mn3, mn2);
              if (mn1 < mn2) {
                swap(mn1, mn2);
              }
            }
          }
        }
        ++rj;
      }
      {
        mxs[i][j][0] = mn1, mxs[i][j][1] = mn2, mxs[i][j][2] = mn3;
      }
    }
  }

  R res(-inf, 1);
  int ans[4] = {-1, -1, -1, -1};
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
      if (i == j) {
        continue;
      }
      for (int it1 = 0; it1 < 3; ++it1) {
        auto &cur1 = mxs[i][j][it1];
        if (cur1.id == -1 || cur1.id == j) {
          continue;
        }
        for (int it2 = 0; it2 < 3; ++it2) {
          auto &cur2 = mns[j][i][it2];
          if (cur2.id == -1 || cur2.id == i) {
            continue;
          }
          if (cur1.id != cur2.id) {
            auto cur = (cur1 - cur2);
            //eprintf("i = %d  (%d/%d), j = %d  (%d/%d)\n", i, cur1.a, cur1.b, j, cur2.a, cur2.b);
            //eprintf("%d/%d with {%d,%d,%d,%d}\n", cur.a, cur.b, cur1.id, j, i, cur2.id);
            if (res < cur) {
              res = cur;
              ans[2] = i, ans[1] = j;
              ans[0] = cur1.id, ans[3] = cur2.id;
            }
          }
        }
      }
    }
  }

  //eprintf("%d/%d\n", res.a, res.b);
  for (int i = 0; i < 4; ++i) {
    //eprintf("%d%c", ans[i], " \n"[i == 3]);
    printf("%d%c", a[ans[i]].id + 1, " \n"[i == 3]);
  }
}

int main() {
  precalc();
#ifdef LOCAL
  freopen(TASK ".out", "w", stdout);
  assert(freopen(TASK ".in", "r", stdin));
#endif

  while (1) {
    if (!read()) {
      break;
    }
    solve();
#ifdef DEBUG
    eprintf("Time %.2f\n", (double) clock() / CLOCKS_PER_SEC);
#endif
  }
  return 0;
}
