import random
random.seed("spb-team-2016/hitches")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test(['******',
                         '*.*.*.',
                         '*.*.*.',
                         '*.....',
                         '*.....'],
                         ['#.#.#.#.',
                          '#.#.#.#.',
                          '#######.'])
                          
    def generate_min_tests(self):
        self.print_test(['*****.',
                         '*.*...',
                         '*.**..'],
                        ['...#.#...',
                         '...#.#...',
                         '#########'])
        self.print_test(['*'], ['#'])
        self.print_test(['.*'], ['#'])
        self.print_test(['........',
                         '........',
                         '........',
                         '...**...',
                         '........',
                         '........'],
                        ['#.#.#.#',
                         '#.#.#.#',
                         '#.#.#.#',
                         '#.#.#.#',
                         '#######'])
                                                                    
    def generate_hand_tests(self):
        self.print_test(['*******',
                         '*.....*',
                         '*.....*',
                         '*.....*',
                         '*.....*'],
                        ['.#...#.',
                         '.##.##.',
                         '..###..'])
        self.print_test(['*',
                         '*',
                         '*',
                         '*',
                         '*',
                         '*'],
                        ['##..##.',
                         '.####..',
                         '..##...'])
        self.print_test(['.**.**.',
                         '..***..',
                         '...*...'],
                        ['#.....#.',
                         '#.....#.',
                         '#.....#.',
                         '#.....#.',
                         '#######.'])
        self.print_test(['.*****.',
                         '.*...*.',
                         '.*****.',
                         '..***..'],
                        ['#.....#',
                         '#.....#',
                         '#.....#',
                         '#.....#',
                         '#######'])

    def add_empty_columns_simple(self, matrix):
        left = random.randint(0, 300 - len(matrix[0]))
        right = random.randint(0, 300 - len(matrix[0]) - left)
        for i in range(len(matrix)):
            matrix[i] = list(('.' * left) + ''.join(matrix[i]) + ('.' * right))
        return matrix

    def add_empty_columns(self, matrix):
        left = random.randint(0, 300 - len(matrix[0]))
        right = random.randint(0, 300 - len(matrix[0]) - left)
        for i in range(len(matrix)):
            matrix[i] = list(('.' * left) + ''.join(matrix[i]) + ('.' * right))
        leftc = random.randint(0, min(3, left))
        rightc = random.randint(0, min(3, right))
        cntl = [0 for _ in range(leftc)]
        cntr = [0 for _ in range(rightc)]
        maxy = 0
        c = '*'
        for i in range(len(matrix)):
            for j in range(len(matrix[i])):
                if matrix[i][j] != '.':
                    c = matrix[i][j]
                    maxy = i
        mx = len(matrix)
        last = 0
        first = float('inf')
        for i in range(len(matrix[0])):
            if matrix[0][i] == c:
                last = i
                first = min(first, i)
        last += 1
        first -= 1
        
        for i in range(leftc):
            cntl[i] = random.randint(1, min(300, maxy + 60))
            mx = max(mx, cntl[i])
        for i in range(rightc):
            cntr[i] = random.randint(1, min(300, maxy + 60))
            mx = max(mx, cntr[i])
        sz = len(matrix)
        for i in range(mx - sz):
            matrix.append(list('.' * len(matrix[0])))
        for i in range(leftc):
            for j in range(cntl[i]):
                matrix[j][first - i] = c
        for i in range(rightc):
            for j in range(cntr[i]):
                matrix[j][last + i] = c
        return matrix

    def generate_random_test(self, maxn, maxm):
        n = maxn
        m = maxm
        field = [['.' for j in range(m)] for i in range(n)]
        endr = random.randint(0, m - 1)
        startz = random.randint(0, endr)
        for i in range(m):
            if i < startz:
                field[n - 1][i] = '#'
                if random.randint(1, 3) > 1:
                    cnt = random.randint(1, n - 1)
                    for j in range(1, cnt + 1):
                        field[n - j - 1][i] = '#'
            else:
                j = n - 1
                if i <= endr:
                    field[n - 1][i] = '#'
                    j -= 1
                    if random.randint(1, 3) > 1:
                        cnt = random.randint(1, n - 2)
                        for j in range(1, cnt + 1):
                            field[n - j - 1][i] = '#'
                            j -= 1
                    field[0][i] = '*'
                    if random.randint(1, 3) > 1:
                        cnt = random.randint(0, j)
                        for x in range(cnt):
                            field[x][i] = '*'
                else:
                    field[0][i] = '*'
                    if random.randint(1, 3) > 1:
                        cnt = random.randint(0, n - 1)
                        for x in range(cnt):
                            field[x + 1][i] = '*'
        a = []
        b = []
        for i in range(n):
            linea = ['.' for _ in range(m)]
            lineb = ['.' for _ in range(m)]
            for j in range(m):
                if field[i][j] == '*':
                    linea[j] = '*'
                if field[i][j] == '#':
                    lineb[j] = '#'
            a.append(linea)
            b.append(lineb)
        self.print_test(self.add_empty_columns(a), self.add_empty_columns_simple(b))

    def generate_max_tests(self, maxn):
        self.print_test([list('*' * 300)], [list('#' * 300)])
        self.print_test([list('.' * 300)] * 299 + [list('*' * 300)], [list('.' * 300)] * 299 + [list('#' * 300)])
        self.print_test([list('*' + '.' * 299)] * 299 + [list('*' * 300)], [list('#' + '.' * 299)] * 299 + [list('#' * 300)])
        self.print_test([list('*' * 300)] * 300, [list('#' * 300)] * 300)
        self.print_test([list('*' * 300)] * 300, [list('.' * 300)] * 299 + [list('#' * 300)])
        self.print_test([list('*' * 300)] * 300, [list('.' * 299 + '#')] * 299 + [list('#' * 300)])        

    def print_test(self, detail, mold):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)

        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(len(detail), len(detail[0]), file=test_file)
        print('\n'.join(''.join(element) for element in detail), file=test_file)
        print(len(mold), len(mold[0]), file=test_file)
        print('\n'.join(''.join(element) for element in mold), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        ns = [5, 10, 25, 50, 100, 300]
        for n in ns:
            for m in ns:
                self.generate_random_test(n, m)
        self.generate_max_tests(1000)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
