#include <bits/stdc++.h>

const int maxn = 400;

void readMatrix(int &n, int &m, std::vector<std::vector<char>> &matrix) {
  scanf("%d%d", &n, &m);
  matrix.resize(n);
  char s[maxn];
  for (int i = 0; i < n; i++) {
    scanf("%s", s);
    matrix[i].resize(m);
    for (int j = 0; j < m; j++) {
      matrix[i][j] = s[j];
    }
  }
}

int main() {
  int nDetail, mDetail;
  std::vector<std::vector<char>> detail;
  readMatrix(nDetail, mDetail, detail);
  int nMold, mMold;
  std::vector<std::vector<char>> mold;
  readMatrix(nMold, mMold, mold);
  std::vector<int> upperCell(mMold, -1);
  std::set<std::pair<int, int>> used;
  for (int i = 0; i < nMold; i++) {
    for (int j = 0; j < mMold; j++) {
      if (mold[i][j] == '#') {
        upperCell[j] = std::max(upperCell[j], nMold - i - 1);
        used.emplace(nMold - i - 1, j);
      }
    }
  }
  std::vector<std::pair<int, int>> dcoords;
  for (int i = 0; i < nDetail; i++) {
    for (int j = 0; j < mDetail; j++) {
      if (detail[i][j] == '*') {
        dcoords.emplace_back(nDetail - i - 1, j);
      }
    }
  }
  int answer = 0;
  for (int shift = -mDetail + 1; shift < mMold; shift++) {
    std::vector<std::pair<int, int>> ds(dcoords.size());
    int moves = INT_MAX;
    for (size_t i = 0; i < ds.size(); i++) {
      ds[i] = {dcoords[i].first + nMold, dcoords[i].second + shift};
      int upper = (0 <= ds[i].second && ds[i].second < mMold) ? upperCell[ds[i].second] : -1;
      moves = std::min(moves, ds[i].first - upper - 1);
    }
    int hitches = 0;
    for (auto &cs : ds) {
      cs.first -= moves;
      //std::cerr << cs.first << ' ' << cs.second << '\n';
      hitches += used.count({cs.first, cs.second - 1});
    }
    answer = std::max(answer, hitches);
  }
  printf("%d\n", answer);
  return 0;
}